import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class ScsSchool {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  Name?: string;
  Code?: string;
  ShortName?: string;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const ScsSchoolSchema = defineEntity({
  class: ScsSchool,
  comment: '学校表',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    Name: p.string().name('Name').length(50).nullable().comment('学校名称'),
    Code: p.string().name('Code').nullable().comment('学校编码(01-99)').unique('idx_SCS_School_01'),
    ShortName: p.string().name('ShortName').length(20).nullable().comment('学校简称'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
